#define IMGUI_DISABLE_INCLUDE_IMCONFIG_H
#define IMGUI_HAS_DOCK 1

#include "CommonHeaders.h"
#include "HotkeysManager.h"
#include "OSDManager.h"
#include <chrono>

// Screen informations
static int screenWidth = GetSystemMetrics(SM_CXSCREEN);
static int screenHeight = GetSystemMetrics(SM_CYSCREEN);
static float aspectRatio = (float)screenWidth / screenHeight;

// Core game dll functions declarations
typedef void (*SetBoolFn)(bool, bool);
typedef void (*SetFixesFn)(GameFixes, bool);
typedef void (*SetFloatFn)(GameSetting, float);

static HMODULE fixLib = nullptr;
static LONG g_coreInitialized = 0;
static LONG g_hotkeysInitialized = 0;
static LONG g_uniformReseted = 0; 
static SetBoolFn SetFixEnabled = nullptr;
static SetFixesFn SetFixes = nullptr;
static SetFloatFn SetValues = nullptr;
void SetFixesEnabled(GameFixes fix, bool value) { if (SetFixes) SetFixes(fix, value); }

//static SetIntFn SetFOV = nullptr;
static GetGameInfosStruct GetGameInfos = nullptr;

// Plugin variables for checkboxes and sliders
bool fix_enabled = false;
bool fov_fix_enabled = false;
bool camera_fix_enabled = false;
bool ultrawide_fix_enabled = false;
bool HUD_fix_enabled = false;
bool sharpening_fix_enabled = false;
bool DOF_fix_enabled = false;
bool Vignetting_fix_enabled = false;
bool Fog_fix_enabled = false;
bool Time_Dilation_fix_enabled = false;
bool GodMode_fix_enabled = false;
bool Stamina_fix_enabled = false;
bool Mana_fix_enabled = false;
bool console = true;
int worldFOVvalue = 0;
float cameraDistancevalue = 1.f;
float sharpeningValue = 3.22f;
int HUDvalue = 0;
float worldTimeDilationValue = 1.f;
float AITimeDilationValue = 1.f;
float OSD_duration = 3.f;

// Overlays popups
static bool popup_Informations = false;
static bool show_log_overlay = false;
static std::string log_content;

// Plugin settings
const std::string SETTINGS_FILE = "./pluginsettings.ini";
const char* FIX_VERSION = "1.0.1";
const char* FIX_INFORMATIONS = "This fix allows to:\n - Control FOV in game.\n - Control camera distance.\n - Enable ultrawide.\n - Enable HUD scaling.\n - Control image sharpening.\n - Disable Depth of field.\n - Disable vignetting.\n - Disable fog.\n - Re enable dev console.\n - Enable cheats.";
const char* DONATION_URL = "https://buymeacoffee.com/k4sh44";

// Scaling factor based on screen resolution
float scale = (float)screenHeight / 1200;

// Prepare arrays of checkboxes for ImGui
static FixToggle individualFixes[] = {
    { "FOV", &fov_fix_enabled, GameFixes::FOV },
    { "HUD", &HUD_fix_enabled, GameFixes::HUD , "this fix is only necessary if you wish fine HUD scaling."},
    { "Vignetting", &Vignetting_fix_enabled, GameFixes::Vignetting },
    { "Fog", &Fog_fix_enabled, GameFixes::Fog },
    { "Ultrawide", &ultrawide_fix_enabled, GameFixes::UltraWide },
    { "Camera distance", &camera_fix_enabled, GameFixes::Camera },
    { "Image sharpening", &sharpening_fix_enabled, GameFixes::Sharpening },
    { "Depth of field", &DOF_fix_enabled, GameFixes::DOF }
};

static FixToggle cheatFixes[] = {
    { "Time dilation", &Time_Dilation_fix_enabled, GameFixes::TimeDilation, "ALT + 1 (top keyboard row) to toggle." },
    { "God Mode",&GodMode_fix_enabled, GameFixes::GodMode, "ALT + 2 (top keyboard row) to toggle.\nHP will always be restored to max." },
    { "Stamina",&Stamina_fix_enabled, GameFixes::Stamina, "ALT + 3 (top keyboard row) to toggle.\nStamina will always be restored to max." },
    { "Mana",&Mana_fix_enabled, GameFixes::Mana, "ALT + 4 (top keyboard row) to toggle\nMana will always be restored to max." }
};
// Prepare array of sliders for ImGui
static SliderFix2 sliders[6];

// Load and unload game core dll functions /!\ necessary
static void LoadFixDLL() {
    if (InterlockedCompareExchange(&g_coreInitialized, 1, 0) != 0)
        return;

    if (GetModuleHandleA("BlackMythWukongCore.dll") == nullptr) {
        fixLib = LoadLibraryA("BlackMythWukongCore.dll");

        if (!fixLib) {
            MessageBoxA(nullptr, "Impossible to load game core dll", "Erreur", MB_OK);
            return;
        }

        SetFixEnabled = (SetBoolFn)GetProcAddress(fixLib, "SetFixEnabled");
        SetFixes = (SetFixesFn)GetProcAddress(fixLib, "SetFixesEnabled");
        SetValues = (SetFloatFn)GetProcAddress(fixLib, "SetValues");
        GetGameInfos = (GetGameInfosStruct)GetProcAddress(fixLib, "GetGameInfos");

        // Apply initial values loaded from settings
        if (SetValues) {
            SetValues(GameSetting::FOV, worldFOVvalue);
            SetValues(GameSetting::CameraDistance, cameraDistancevalue);
            SetValues(GameSetting::Sharpening, sharpeningValue);
            SetValues(GameSetting::HUD, HUDvalue);
            SetValues(GameSetting::WorldTimeDilation, worldTimeDilationValue);
            SetValues(GameSetting::AITimeDilation, AITimeDilationValue);
        }
        if (SetFixEnabled) SetFixEnabled(fix_enabled, true);
        if (SetFixes) {
            SetFixes(GameFixes::FOV, fov_fix_enabled);
            SetFixes(GameFixes::Camera, camera_fix_enabled);
            SetFixes(GameFixes::UltraWide, ultrawide_fix_enabled);
            SetFixes(GameFixes::HUD, HUD_fix_enabled);
            SetFixes(GameFixes::DOF, DOF_fix_enabled);
            SetFixes(GameFixes::Sharpening, sharpening_fix_enabled);
            SetFixes(GameFixes::Vignetting, Vignetting_fix_enabled);
            SetFixes(GameFixes::Fog, Fog_fix_enabled);
            SetFixes(GameFixes::TimeDilation, Time_Dilation_fix_enabled);
            SetFixes(GameFixes::GodMode, GodMode_fix_enabled);
            SetFixes(GameFixes::Stamina, Stamina_fix_enabled);
            SetFixes(GameFixes::Mana, Mana_fix_enabled);
            SetFixes(GameFixes::DevConsole, console);
        }

        sliders[0] = { "In game additional FOV", "##FOVValue", SliderType::Int, &worldFOVvalue, -20, 40, GameSetting::FOV, SetValues };
        sliders[1] = { "HUD scaling", "##HUDValue", SliderType::Int, &HUDvalue, -20, 40, GameSetting::HUD, SetValues };
        sliders[2] = { "Camera distance (*)", "##CameraOffset", SliderType::Float, &cameraDistancevalue, 0, 4, GameSetting::CameraDistance, SetValues, "%.1f",
                       "Value is a multiplier." };
        sliders[3] = { "Image sharpening", "##SharpeningValue", SliderType::Float, &sharpeningValue, 0, 10, GameSetting::Sharpening, SetValues, "%.1f",
                       "Default value is 3.2." };
        sliders[4] = { "World time dilation", "##WorldTimeDilationValue", SliderType::Float, &worldTimeDilationValue, 0.f, 2.f,GameSetting::WorldTimeDilation , SetValues, "%.1f",
                       "Will affect everything in the world.\nDefault value is 1." };
        sliders[5] = { "AI dilation", "##AITimeDilationValue", SliderType::Float, &AITimeDilationValue, 0.f, 2.f,GameSetting::AITimeDilation , SetValues, "%.1f" };
    }
}

// Settings functions
static void SaveSettings() {
    ini::IniFile pluginIniFile;
    pluginIniFile["1#General fix"].setComment(std::vector<std::string>{ "The following sections are saved by plugin",
                                                                        "You should not need to modify them",
                                                                        " ",
                                                                        "Controls if fix mod (globally) is enabled",
                                                                        "Set Console to false if you don't want to enable it" });
    pluginIniFile["1#General fix"]["Enabled"] = fix_enabled;
    pluginIniFile["1#General fix"]["Console"] = console;
    pluginIniFile["2#Individual fix"].setComment("Controls each fix individually");
    pluginIniFile["2#Individual fix"]["FOV"] = fov_fix_enabled;
    pluginIniFile["2#Individual fix"]["UltraWide"] = ultrawide_fix_enabled;
    pluginIniFile["2#Individual fix"]["Camera"] = camera_fix_enabled;
    pluginIniFile["2#Individual fix"]["HUD"] = HUD_fix_enabled;
    pluginIniFile["2#Individual fix"]["DOF"] = DOF_fix_enabled;
    pluginIniFile["2#Individual fix"]["Sharpening"] = sharpening_fix_enabled;
    pluginIniFile["2#Individual fix"]["Vignetting"] = Vignetting_fix_enabled;
    pluginIniFile["2#Individual fix"]["Fog"] = Fog_fix_enabled;
    pluginIniFile["2#Individual fix"]["Time dilation"] = Time_Dilation_fix_enabled;
    pluginIniFile["2#Individual fix"]["God mode"] = GodMode_fix_enabled;
    pluginIniFile["2#Individual fix"]["Stamina"] = Stamina_fix_enabled;
    pluginIniFile["2#Individual fix"]["Mana"] = Mana_fix_enabled;
    pluginIniFile["3#Fixes tuning"].setComment("Individual fix fine tune");
    pluginIniFile["3#Fixes tuning"]["World FOV"] = worldFOVvalue;
    pluginIniFile["3#Fixes tuning"]["Sharpening value"] = sharpeningValue;
    pluginIniFile["3#Fixes tuning"]["Camera distance"] = cameraDistancevalue;
    pluginIniFile["3#Fixes tuning"]["HUD scaling"] = HUDvalue;
    pluginIniFile["3#Fixes tuning"]["World time dilation scale"] = worldTimeDilationValue;
    pluginIniFile["3#Fixes tuning"]["AI time dilation scale"] = AITimeDilationValue;

    pluginIniFile.save(SETTINGS_FILE);
}

static void LoadSettings() {
    ini::IniFile pluginIniFile;
    try {
        pluginIniFile.load(SETTINGS_FILE);
        fix_enabled                 = pluginIniFile["1#General fix"]["Enabled"].as<bool>();
        console                     = pluginIniFile["1#General fix"]["Console"].as<bool>();
        fov_fix_enabled             = pluginIniFile["2#Individual fix"]["FOV"].as<bool>();
        ultrawide_fix_enabled       = pluginIniFile["2#Individual fix"]["UltraWide"].as<bool>();
        camera_fix_enabled          = pluginIniFile["2#Individual fix"]["Camera"].as<bool>();
        HUD_fix_enabled             = pluginIniFile["2#Individual fix"]["HUD"].as<bool>();
        DOF_fix_enabled             = pluginIniFile["2#Individual fix"]["DOF"].as<bool>();
        sharpening_fix_enabled      = pluginIniFile["2#Individual fix"]["Sharpening"].as<bool>();
        Vignetting_fix_enabled      = pluginIniFile["2#Individual fix"]["Vignetting"].as<bool>();
        Fog_fix_enabled             = pluginIniFile["2#Individual fix"]["Fog"].as<bool>();
        Time_Dilation_fix_enabled   = pluginIniFile["2#Individual fix"]["Time dilation"].as<bool>();
        GodMode_fix_enabled         = pluginIniFile["2#Individual fix"]["God mode"].as<bool>();
        Stamina_fix_enabled         = pluginIniFile["2#Individual fix"]["Stamina"].as<bool>();
        Mana_fix_enabled            = pluginIniFile["2#Individual fix"]["Mana"].as<bool>();
        worldFOVvalue               = pluginIniFile["3#Fixes tuning"]["World FOV"].as<int>();
        cameraDistancevalue         = pluginIniFile["3#Fixes tuning"]["Camera distance"].as<float>();
        sharpeningValue             = pluginIniFile["3#Fixes tuning"]["Sharpening value"].as<float>();
        HUDvalue                    = pluginIniFile["3#Fixes tuning"]["HUD scaling"].as<int>();
        worldTimeDilationValue      = pluginIniFile["3#Fixes tuning"]["World time dilation scale"].as<float>();
        AITimeDilationValue         = pluginIniFile["3#Fixes tuning"]["AI time dilation scale"].as<float>();
    }
    catch (const std::exception& e) {}
}

// Read plugin log file
void read_log_file(const std::string& filename) {
    std::ifstream file(filename);
    if (!file.is_open()) {
        log_content = "Impossible to open file : " + filename;
        return;
    }

    std::ostringstream ss;
    ss << file.rdbuf();
    log_content = ss.str();
}

// Initialize ImGui widgets for Reshade
static void on_overlay_draw(reshade::api::effect_runtime* runtime) {
    ImGui::SetNextWindowSize(ImVec2(350 * scale, 150 * scale), ImGuiCond_Once);

    ImGui::PushStyleColor(ImGuiCol_Button, ImVec4(0.84f, 0.12f, 0.51f, 1.0f)); // pink
    ImGui::PushStyleColor(ImGuiCol_ButtonHovered, ImVec4(0.84f, 0.12f, 0.51f, 1.0f)); // pink
    ImGui::PushStyleColor(ImGuiCol_ButtonActive, ImVec4(0.84f, 0.2f, 0.51f, 1.0f)); // pink
    ImGui::PushStyleColor(ImGuiCol_Text, ImVec4(0.8f, 1.f, 1.f, 1.f)); // white
    if (ImGui::Button("Like my work ? Consider donation")) ShellExecuteA(NULL, "open", DONATION_URL, NULL, NULL, SW_SHOWNORMAL); // Donation
    ImGui::PopStyleColor(4); // Restore color
    ImGui::SameLine();
    if (ImGui::Button("Fix informations")) popup_Informations = true; // Fix information
    ImGui::SameLine();
    if (ImGui::Button("View logs")) {
        read_log_file("BlackMythWukong.log");
        show_log_overlay = true; // Fix information
    }

    if (popup_Informations) {
        ImGui::Begin("Informations", &popup_Informations, ImGuiWindowFlags_AlwaysAutoResize);
        ImGui::Text("Version : %s", FIX_VERSION);
        ImGui::Text(FIX_INFORMATIONS);
        ImGui::End();
    }

    if (show_log_overlay) {
        ImGui::Begin("Game log", &show_log_overlay, ImGuiWindowFlags_AlwaysAutoResize);
        ImGui::TextUnformatted(log_content.c_str());
        ImGui::End();
    }

    if (ImGui::BeginTabBar("MainTabs")) {
        if (ImGui::BeginTabItem("Fixes")) {
            ImGui::PushStyleVar(ImGuiStyleVar_CellPadding, ImVec2(10 * scale, 10 * scale));
            if (ImGui::BeginTable("FixesTable", 2, ImGuiTableFlags_SizingStretchSame)) {
                ImGui::TableSetupColumn("LeftFix", ImGuiTableColumnFlags_WidthStretch, 0.4f);
                ImGui::TableSetupColumn("RightFix", ImGuiTableColumnFlags_WidthStretch, 0.6f);
                ImGui::TableNextRow();

                // Drawing a left column with slider and general fix
                ImGui::TableSetColumnIndex(0);
                if (ImGui::CollapsingHeader("Enable fixes", ImGuiTreeNodeFlags_DefaultOpen))
                    if (ImGui::Checkbox("Fix enabled", &fix_enabled)) {
                        if (SetFixEnabled) SetFixEnabled(fix_enabled, false);
                        SaveSettings();
                    }
                // Individual fixes
                ImGui::TableSetColumnIndex(1);
                if (ImGui::CollapsingHeader("Individual fixes", ImGuiTreeNodeFlags_DefaultOpen)) {
                    if (ImGui::BeginTable("IndividualFixesTable", 2, ImGuiTableFlags_SizingStretchSame)) {
                        ImGui::TableSetupColumn("IndFix1", ImGuiTableColumnFlags_WidthStretch, 0.4f);
                        ImGui::TableSetupColumn("IndFix2", ImGuiTableColumnFlags_WidthStretch, 0.6f);
                        ImGui::TableNextRow();

                        ImGui::TableSetColumnIndex(0);
                        for (int i = 0; i < 4; ++i) DrawFixCheckbox(individualFixes[i]);

                        ImGui::TableSetColumnIndex(1);
                        for (int i = 4; i < IM_ARRAYSIZE(individualFixes); ++i) DrawFixCheckbox(individualFixes[i]);

                        ImGui::EndTable();
                    }
                }
                ImGui::EndTable();
            }

            ImGui::SetCursorPosY(ImGui::GetCursorPosY() - 2);
            if (ImGui::BeginTable("FixesSliders", 2, ImGuiTableFlags_SizingStretchSame)) {
                ImGui::TableNextRow();
                ImGui::TableSetColumnIndex(0);
                DrawSlider2(sliders[0], 200);
                DrawSlider2(sliders[1], 200);
                ImGui::TableSetColumnIndex(1);
                DrawSlider2(sliders[2], 200);
                DrawSlider2(sliders[3], 200);
                ImGui::EndTable();
            }
            ImGui::PopStyleVar();
            ImGui::EndTabItem();
        }

        if (ImGui::BeginTabItem("Cheats")) {
            for (const auto& cheat : cheatFixes) DrawFixCheckbox(cheat);

            ImGui::PushStyleVar(ImGuiStyleVar_CellPadding, ImVec2(10 * scale, 10 * scale));
            if (ImGui::BeginTable("SlidersTable", 2, ImGuiTableFlags_SizingStretchSame)) {
                ImGui::TableSetupColumn("LeftSliders", ImGuiTableColumnFlags_WidthStretch, 0.5f);
                ImGui::TableSetupColumn("RightSliders", ImGuiTableColumnFlags_WidthStretch, 0.5f);
                ImGui::TableNextRow();

                ImGui::TableSetColumnIndex(0);
                DrawSlider2(sliders[4], 180);
                ImGui::TableSetColumnIndex(1);
                DrawSlider2(sliders[5], 180);
                ImGui::EndTable();
            }
            ImGui::PopStyleVar();
            ImGui::EndTabItem();
            if (ImGui::CollapsingHeader("Cheat informations", ImGuiTreeNodeFlags_DefaultOpen)) {
                if (GetGameInfos) {
                    GameInfos infos{};
                    GetGameInfos(&infos);
                    ImGui::TextColored(ImColor(48, 179, 25), "Wukong health: %.1f - Stamina: %.1f - Mana: %.1f", infos.Health, infos.Stamina, infos.Mana);
                }
            }
        }
        ImGui::EndTabBar();

        // Fix status
        if (ImGui::CollapsingHeader("Fix informations", ImGuiTreeNodeFlags_DefaultOpen)) {
            ImGui::Text("Screen width: %d, height: %d, aspect ratio: %.2f", screenWidth, screenHeight, aspectRatio);
            if (GetGameInfos) {
                GameInfos infos{};
                GetGameInfos(&infos);
                if (infos.consoleEnabled)
                    ImGui::Text("Console enabled and bound to key F2");
                ImGui::TextColored(ImColor(48, 179, 25), "FOV In: %.2f, Out: %.2f", infos.FOVIn, infos.FOVOut);
                ImGui::TextColored(ImColor(48, 179, 25), "Camera distance In: %.2f, Out: %.2f", infos.cameraIn, infos.cameraOut);
            }
        }
    }
}

static void on_reshade_present(reshade::api::effect_runtime* runtime) {
    static auto last = std::chrono::steady_clock::now();
    auto now = std::chrono::steady_clock::now();
    float dt = std::chrono::duration<float>(now - last).count();
    last = now;

    ProcessHotkeys(runtime);
    UpdateOSD(runtime, dt);
}

// Retrieve all shader uniform variables
static void on_reshade_begin_effects(reshade::api::effect_runtime* runtime, reshade::api::command_list* cmd_list,
    reshade::api::resource_view rtv, reshade::api::resource_view rtv_srgb) {
    if (!runtime) return;
    FindAllUniformVariables(runtime, OSD_SHADER_NAME); // Find all uniforms and set their handle

    if (InterlockedCompareExchange(&g_uniformReseted, 1, 0) != 0) return; // reset OSD uniforms once
    ResetAllUniformVariables(runtime, OSD_SHADER_NAME);
    runtime->save_current_preset(); // Save shader preset
}

static void InitializeHotkeys() { // Initialize hotkeys for cheats
    if (InterlockedCompareExchange(&g_hotkeysInitialized, 1, 0) != 0) return; // Initialize hotkeys once

    RegisterHotkey('1', Modifier::Alt, [] {
        ToggleOSD(Time_Dilation_fix_enabled, GameFixes::TimeDilation, u_td_show, u_td_enabled, OSD_duration,
            { {u_td_world, worldTimeDilationValue}, {u_td_AI, AITimeDilationValue} }); });

    RegisterHotkey('2', Modifier::Alt, [] { ToggleOSD(GodMode_fix_enabled, GameFixes::GodMode, u_GodMode_show, u_GodMode_enabled, OSD_duration); });
    RegisterHotkey('3', Modifier::Alt, [] { ToggleOSD(Stamina_fix_enabled, GameFixes::Stamina, u_Stamina_show, u_Stamina_enabled, OSD_duration); });
    RegisterHotkey('4', Modifier::Alt, [] { ToggleOSD(Mana_fix_enabled, GameFixes::Mana, u_Mana_show, u_Mana_enabled, OSD_duration); });
}
// Main dll intrance
BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD ul_reason_for_call, LPVOID) {
    switch (ul_reason_for_call) {
        case DLL_PROCESS_ATTACH:
            if (!reshade::register_addon(hinstDLL))
                return FALSE;
            LoadSettings();

            reshade::register_overlay("Black Myth Wukong", &on_overlay_draw);
            reshade::register_event<reshade::addon_event::init_effect_runtime>(
                [](reshade::api::effect_runtime* runtime) {
                    LoadFixDLL();
                    InitializeHotkeys();
                });
            reshade::register_event<reshade::addon_event::reshade_present>(&on_reshade_present);
            reshade::register_event<reshade::addon_event::reshade_begin_effects>(&on_reshade_begin_effects);
            break;
        case DLL_PROCESS_DETACH:
            reshade::unregister_event<reshade::addon_event::reshade_present>(&on_reshade_present);
            reshade::unregister_event<reshade::addon_event::reshade_begin_effects>(&on_reshade_begin_effects);
            reshade::unregister_addon(hinstDLL);
            break;
    }
    return TRUE;
}